#ifndef UpperTester_LAYER_H
#define UpperTester_LAYER_H

#include "Layer.hh"
#include "UpperTesterCodec.hh"

namespace LibItsGeoNetworking__TestSystem {
  class UpperTesterPort;
}

namespace LibItsGeoNetworking__TypesAndValues {
  class UtGnInitialize;
  class UtGnChangePosition;
  class UtGnTrigger;
  class UtAutoInteropTrigger;
}

class UpperTesterLayer : public TLayer<LibItsGeoNetworking__TestSystem::UpperTesterPort> {
  Params _params;
  UpperTesterCodec _codec;
  
public:
  UpperTesterLayer() : TLayer<LibItsGeoNetworking__TestSystem::UpperTesterPort>(), _params(), _codec() {};
  UpperTesterLayer(const std::string & p_type, const std::string & param);
  virtual ~UpperTesterLayer() {};

  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtGnInitialize& send_par, Params& params);
  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtGnChangePosition& send_par, Params& params);
  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtGnTrigger& send_par, Params& params);
  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtAutoInteropTrigger& send_par, Params& params);
  
  virtual void sendData(OCTETSTRING& data, Params& params);
  virtual void receiveData(OCTETSTRING& data, Params& info);
};

#endif
